#include "checkers.h"

#define MAX_DEPTH 11
/* define PRUNING if you want alpha-beta pruning to be in effect*/
#define PRUNING
/* the most negative and positive value that the Eval_leaf function may put out*/
#define NEG_INFINITY -32767
#define POS_INFINITY 32767
/*#define DEBUG*/

typedef game gt_data;
typedef game gt_unmove;
typedef move gt_move;
typedef moves gt_moves;
typedef signed long int gt_score;

typedef struct {
  int depth;
  int parity;
#ifdef DEBUG
  int node_count;
#endif
  gt_data current_data;
} gt_mimx_data;

/* A function which the user calls to try to find the best move*/
void Minimax(gt_data *data, gt_move *chose_move, int parity);

/*functions which Minimax calls*/
/* determines the score of a leaf nodes position*/
void Gt_evaluate(gt_mimx_data *current_board,gt_score *chosen_score,gt_score best_score);

/* modifies the game data before recursion with a move*/
void Gt_move(gt_mimx_data *current_mimx_data,gt_move *move,gt_unmove *unmove);

/* unmodifies the game data with the move */
/* Apply followed by Unapply should leave the range the same as when Apply was first called */
void Gt_unmove(gt_mimx_data *current_board,gt_unmove *unmove);

/*if FAST is not defined you must define this function*/
void Gt_generate_moves(gt_mimx_data *current_mimx_data,gt_moves *array_of_moves);
